#
# spec file for package suse-build-key
#
# Copyright (c) 2023 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           suse-build-key
BuildRequires:  gpg
Provides:       build-key
Summary:        The public gpg key for rpm package signature verification
License:        GPL-2.0-or-later
Group:          System/Packages
Version:        12.0
Release:        13.1

# pub  2048R/39DB7C82 2013-01-31 SuSE Package Signing Key <build@suse.de>
# The main package signing key.
Source0:        gpg-pubkey-39db7c82-5f68629b.asc
#pub   rsa4096/0xF74F09BC3FA1D6CE 2023-01-19 [SC] [expires: 2027-01-18]
#      Key fingerprint = 7F00 9157 B127 B994 D5CF  BE76 F74F 09BC 3FA1 D6CE
#uid                             SUSE Package Signing Key <build@suse.de>
Source4:        gpg-pubkey-3fa1d6ce-63c9481c.asc

# pub  2048R/50A3DD1C 2013-01-14 SuSE Package Signing Key (reserve key) <build@suse.de>
# Fallback key if main key gets lost.
Source1:        gpg-pubkey-50a3dd1c-50f35137.asc
# new reserver key RSA 4096 bit
#pub   rsa4096/0xA1BFC02BD588DC46 2023-01-19 [SC] [expires: 2033-01-16]
#      Key fingerprint = B56E 5601 41D8 F654 2DFF  3BF9 A1BF C02B D588 DC46
#uid                             SUSE Package Signing Key (reserve key) <build@suse.de>
Source9:        gpg-pubkey-25db7ae0-645bae34.asc

# pub  1024R/307E3D54 2006-03-21 SuSE Package Signing Key <build@suse.de>
# SLES 10 key.
Source2:        gpg-pubkey-307e3d54-5aaa90a5.asc

#pub   rsa2048/0x8EFE1BC4D4ADE9C3 2017-12-11 [SC] [expires: 2027-12-09]
#     Key fingerprint = 0EE9 CA43 0050 9E29 17A0  54ED 8EFE 1BC4 D4AD E9C3
# container key used by Container TUF style signing.
Source3:        build-container-d4ade9c3-5a2e9669.asc
# same, in PEM format
Source10:       build-container-d4ade9c3-5a2e9669.pem

# New ALP Keys
#pub   rsa4096/0xFEC28EAF09D9EA69 2023-05-10 [SC] [expires: 2027-05-09]
#      Key fingerprint = 1C59 D66F CD52 563A 1693  3DBC FEC2 8EAF 09D9 EA69
#uid                             ALP Package Signing Key <build-alp@suse.de>
Source5:        gpg-pubkey-09d9ea69-645b99ce.asc
# reserve key
#pub   rsa4096/0xC7B81E4373F03759 2022-04-29 [SC] [expires: 2032-04-26]
#      Key fingerprint = 5056 7568 F292 0FF1 65B2  5FB2 C7B8 1E43 73F0 3759
#uid                             ALP Package Signing Key (reserve key) <build-alp@suse.de>
Source6:        gpg-pubkey-73f03759-626bd414.asc

# new 4096 bit SLES container key.
#pub   rsa4096/0x100CEB438FD6C337 2023-01-19 [SC] [expires: 2027-01-18]
#      Key fingerprint = 2BFA 4649 1A1C FFA8 31EF  C4B6 100C EB43 8FD6 C337
#uid                             SUSE Linux Container Signing Key <build-container@suse.de>
Source7:        build-container-8fd6c337-63c94b45.asc
# Exact same key in PEM format for notary and cosign
Source8:        build-container-8fd6c337-63c94b45.pem

# SUSE supplied PTF (program temporary fixes) are signed by this key.
# supplied to be not imported by default
#pub   rsa2048/0x46DFA05C6F5DA62B 2022-02-25 [SC] [expires: 2026-02-24]
#      Key fingerprint = 1604 494D 38DA 2FA7 AA26  97AE 46DF A05C 6F5D A62B
#uid                             SUSE PTF Signing Key <support@suse.com>
Source97:       suse_ptf_key.asc
#pub   rsa4096/0x09461C70AF5425F7 2023-01-19 [SC] [expires: 2027-01-18]
#      Key fingerprint = 6D6C 8072 BF35 2152 3062  D823 0946 1C70 AF54 25F7
#uid                             SUSE PTF Signing Key <support@suse.com>
Source98:       suse_ptf_4096_key.asc

# Use only for email communication!
#pub   rsa4096/0xB205E69BAB2FD922 2020-03-10 [SC] [expires: 2024-02-24]
#      Key fingerprint = 2BAB 445F B9B4 F0D3 30E4  7CB0 B205 E69B AB2F D922
#uid                             SUSE Security Team <security@suse.com>
#uid                             SUSE Security Team <security@suse.de>
#sub   rsa4096/0xA679ED66FD417627 2020-03-10 [E] [expires: 2024-02-24]
Source99:       security_at_suse_de.asc

Source100:      dumpsigs

BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildArch:      noarch
%define keydir  %{_prefix}/lib/rpm/gnupg/keys
%define containerkeydir  %{_prefix}/share/container-keys/
%define pemcontainerkeydir  %{_prefix}/share/pki/containers/

%description
This package contains the gpg keys that are used to sign the
SUSE rpm packages. The keys installed here are not actually
used by anything. rpm/zypper use the keys in the rpm db instead.

%prep
%setup -qcT

%build
cp %SOURCE98 .
cp %SOURCE99 .

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{keydir}
for i in %sources; do
    case "$i" in
        */gpg-pubkey-*.asc|*/*ptf*.asc)
        install -m 644 "$i" $RPM_BUILD_ROOT%{keydir}
        ;;
    esac
done
%if 0%{?suse_version} &&  0%{?suse_version} < 1120
install -m 755 %{SOURCE100} $RPM_BUILD_ROOT/usr/lib/rpm/gnupg
%endif

install -d -m 755 $RPM_BUILD_ROOT%{containerkeydir}/
install -c -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{containerkeydir}/suse-container-key.asc
install -c -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{containerkeydir}/suse-container-key-4096.asc

install -d -m 755 $RPM_BUILD_ROOT%{pemcontainerkeydir}/
install -c -m 644 %{SOURCE10} $RPM_BUILD_ROOT%{pemcontainerkeydir}/suse-container-key.pem
install -c -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{pemcontainerkeydir}/suse-container-key-4096.pem

%files
%defattr(644,root,root)
%doc security_at_suse_de.asc
%attr(755,root,root) %dir %{_prefix}/lib/rpm/gnupg
%attr(755,root,root) %dir %{keydir}
%attr(755,root,root) %dir %{containerkeydir}
%if 0%{?suse_version} &&  0%{?suse_version} < 1120
%attr(755,root,root) %{_prefix}/lib/rpm/gnupg/dumpsigs
%endif
%{keydir}/gpg-pubkey-50a3dd1c-50f35137.asc
%{keydir}/gpg-pubkey-39db7c82-5f68629b.asc
%{keydir}/gpg-pubkey-307e3d54-5aaa90a5.asc
%{keydir}/gpg-pubkey-09d9ea69-645b99ce.asc
%{keydir}/gpg-pubkey-3fa1d6ce-63c9481c.asc
%{keydir}/gpg-pubkey-73f03759-626bd414.asc
%{keydir}/gpg-pubkey-25db7ae0-645bae34.asc
%{keydir}/suse_ptf_4096_key.asc
%{keydir}/suse_ptf_key.asc
%{containerkeydir}/suse-container-key.asc
%{containerkeydir}/suse-container-key-4096.asc
%dir /usr/share/pki/
%dir %{pemcontainerkeydir}/
%{pemcontainerkeydir}/suse-container-key.pem
%{pemcontainerkeydir}/suse-container-key-4096.pem

%changelog
* Mon Oct 16 2023 Marcus Meissner <meissner@suse.com>
- build-container-d4ade9c3-5a2e9669.pem: added missing current
  PEM container key.
- install the PEM files to the container dir, not the .asc files
  (bsc#1216203)
* Tue Sep 12 2023 Marcus Meissner <meissner@suse.com>
- remove gpg, fileutils, mktemp, sh-utils requires as they are not
  needed by the package main functionality, but only by dumpsigs.
* Mon May 15 2023 Marcus Meissner <meissner@suse.com>
- updated with all current changes
  - gpg-pubkey-3fa1d6ce-63c9481c.asc: Upcoming SLE RSA 4096 bit signing key.
  - gpg-pubkey-25db7ae0-645bae34.asc: New SLE RSA 4096 bit backup signing key.
  - gpg-pubkey-09d9ea69-645b99ce.asc: New ALP RSA 4096 bit signing key.
  - gpg-pubkey-73f03759-626bd414.asc: New ALP RSA 4096 bit backup signing key.
  - suse_ptf_key.asc: switch to use current RSA 2048 bit key
  - suse_ptf_4096_key.asc: upcoming RSA 4096 bit key for SUSE PTFs.
  - build-container-8fd6c337-63c94b45.asc: New SLE RSA 4096 bit container signing key (GPG format).
  - build-container-8fd6c337-63c94b45.pem: New SLE RSA 4096 bit container signing key (PEM format).
* Fri Jun 11 2021 Dirk Müller <dmueller@suse.com>
- remove dumpsigs for SLE12+ (rpm 4.x) (bsc#1186827)
* Mon Sep 21 2020 Marcus Meissner <meissner@suse.com>
- suse build key extended (bsc#1176759)
  gpg-pubkey-39db7c82-5847eb1f.asc -> gpg-pubkey-39db7c82-5f68629b.asc
* Thu Aug 13 2020 Marcus Meissner <meissner@suse.com>
- actually the container key is different from the build signing
  key. (PM-1845 bsc#1170347)
* Thu Apr 23 2020 Marcus Meissner <meissner@suse.com>
- add a /usr/share/container-keys/ directory for GPG based Container
  verification.
- Add the SUSE build key as "suse-container-key.asc". (PM-1845 bsc#1170347)
* Wed Mar 11 2020 Marcus Meissner <meissner@suse.com>
- created a new security@suse.de communication key (bsc#1166334)
* Tue Nov 13 2018 meissner@suse.com
- include ptf key in the key directory to avoid it being
  stripped via %%doc stripping. (bsc#1044232)
* Wed Mar 28 2018 meissner@suse.com
- created a new security@suse.de communication key. (bsc#1082022)
- extended the PTF key and the SLE10 build@suse.de key. (bsc#1085512)
* Wed Dec  7 2016 meissner@suse.com
- extend the build@suse.de product key. (bsc#1014151)
  pub  2048R/39DB7C82 2013-01-31 [expires: 2020-12-06]
  uid                            SuSE Package Signing Key <build@suse.de>
* Tue Nov 29 2016 ro@suse.de
- use dumpsigs script from openSUSE to merge code
* Thu Oct  2 2014 meissner@suse.com
- renamed security_at_suse_de.asc to security_at_suse_de_old.asc
- security_at_suse_de.asc: new 4096 bit RSA key.
  pub  4096R/317CD502 2014-10-02 SUSE Security Team <security@suse.de>
  bnc#899509
* Fri Aug 29 2014 meissner@suse.com
- Went to new method again.
  - suse-build-key.gpg blob dropped
  - ship seperate files
* Mon Feb 10 2014 meissner@suse.com
- create suse-build-key.gpg during build.
- Remove old keys from keyring. (fate#314767)
  Keys currently inside the RPM trusted keyring:
  - pub  2048R/39DB7C82 SuSE Package Signing Key <build@suse.de>
  - pub  2048R/50A3DD1C SuSE Package Signing Key (reserve key) <build@suse.de>
- Various keys are moved to the documentation area
  (/usr/share/doc/packages/suse-build-key)
  - build-at-suse-sle11.asc: the old SUSE Linux Enterprise 11 key.
    if SUSE Linux Enterprise 11 packages need to be verified on
    a SUSE Linux Enterprise 12 system.
  - suse_ptf_key.asc: The suse ptf key. For verification of provided PTFs.
  - security_at_suse_de.asc: Use only for email encryption and
    verification purposes when contacting our security contact address
    security@suse.de
* Mon Jan 13 2014 meissner@suse.com
- reverted to contain the fullkeyring build SLE12 Alpha.
- also list the old sle11 build@suse.de key temporary
* Thu Jan  9 2014 meissner@suse.com
- Merged over logic from openSUSE-build-key.
- Got rid of default importing into roots keyring.
- Removed some old keys.
- Clarify that security@suse.de is a email only key
- PTF key is supplied also as %%doc, to not be default
  imported.
- Keys currently inside:
  - pub  2048R/39DB7C82 SuSE Package Signing Key <build@suse.de>
  - pub  2048R/50A3DD1C SuSE Package Signing Key (reserve key) <build@suse.de>
  - pub  1024D/B37B98A9 SUSE PTF Signing Key <support@suse.com>
  - pub  2048R/3D25D3D9 SuSE Security Team <security@suse.de>
* Thu Jan 31 2013 ro@suse.de
- added future signing key for SLES (fate#314767) (bnc#801055)
  using 2048 bit rsa key
* Mon Jan 14 2013 ro@suse.de
- added reserve key for SLES (fate#312896)
  50A3DD1C SuSE Package Signing Key (reserve key) <build@suse.de>
  valid until (2017-01-13)
* Sun Oct 21 2012 ro@suse.de
- export keys to single files in /usr/lib/rpm/gnupg/keys
* Mon Dec 12 2011 ro@suse.de
- reduced key list. remaining keys:
  307E3D54 SuSE Package Signing Key <build@suse.de>
  3D25D3D9 SuSE Security Team <security@suse.de>
  9C800ACA SuSE Package Signing Key <build@suse.de>
  B37B98A9 SUSE PTF Signing Key <support@suse.com>
* Fri Jan 28 2011 ro@suse.de
- if we have to set $HOME, we also have to export the variable
  (bnc#665912)
* Tue May  4 2010 ro@suse.de
- updated keys: (bnc#600157,bnc#599167)
  - 307E3D54 build@suse.de "SuSE Package Signing Key" (2014-05-03)
  - 9C800ACA build@suse.de "SuSE Package Signing Key" (2014-05-03)
  - B37B98A9 support@suse.com "SUSE PTF Signing Key" (2014-05-03)
  - 7E2E3B05 novell-provo-build@novell.com "Novell Provo Build"
    (2014-05-06)
- added keys:
  - 1D061A62 support@novell.com
    "build@novell.com (Novell Linux Products)" (2014-05-06)
* Fri Oct 31 2008 ro@suse.de
- added ptf key, expiring 2010-07-02
* Mon Jun  2 2008 ro@suse.de
- update keys again: for collaboration with rpm, the current
  self-signature needs to be the first signature found in a key
* Mon May  5 2008 ro@suse.de
- updated keys
  9C800ACA,8495160C,307E3D54: extend expiration by 2 years
  until 2010-05-05
  7E2E3B05: extend expiration by 2 years until 2010-05-24
* Mon Mar 19 2007 rguenther@suse.de
- merge suse-build-key keyring to roots gpg pubring
* Mon May 29 2006 ro@suse.de
- added new official provo dsa autobuild key ID 7E2E3B05
* Fri May 19 2006 ro@suse.de
- removed unused provo autobuild key
- added new official provo autobuild key ID A1912208
* Thu Apr 20 2006 ro@suse.de
- add dumpsigs script here to have _one_ place for the script
* Fri Mar 31 2006 ro@suse.de
- added build@suse.de rsa key ID 307E3D54
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Oct 18 2005 ro@suse.de
- use correct provo autobuild key
* Tue Oct 18 2005 ro@suse.de
- added provo autobuild signing key (#128128)
- removed jds key
* Fri May 27 2005 mls@suse.de
- added mktemp to PreReqs [#86177]
* Thu Apr 28 2005 ro@suse.de
- added JDS public key (15c17deb)
* Tue Jan 25 2005 ro@suse.de
- added OES public key (0dfb3188)
* Tue Jun 22 2004 ro@suse.de
- updated build key (expiration changed to 2008-06-21) (#42326)
* Tue Feb 24 2004 hmacht@suse.de
- building as non-root
* Tue Sep  9 2003 ro@suse.de
- ignore return code from first gpg calls
* Tue Sep  9 2003 draht@suse.de
- call gpg twice without any arguments for proper initialization
  inside postinstall
* Tue Sep  9 2003 draht@suse.de
- use temp file instead of pipe due to resource race between two
  instances of gpg in %%post.
* Thu Sep  5 2002 draht@suse.de
- package now installs key from package-owned file into the rpm
  pubring in %%post to allow other key packages to add their keys.
* Tue Aug 20 2002 mmj@suse.de
- Correct PreReq
* Fri Jul 26 2002 kukuk@suse.de
- Change Provides from suse-build-key to build-key
* Wed Feb 20 2002 draht@suse.de
- directory permission problem: 644 -> 755.
* Mon Feb 18 2002 ro@suse.de
- moved to /usr/lib/rpm/gnupg/pubring.pgp
  rpm needs a directory as gpg_path and will use pubring.gpg
  in that directory
* Wed Feb 13 2002 draht@suse.de
- initial package. Contains
  - pub  2048R/3D25D3D9 1999-03-06 SuSE Security Team <security@suse.de>
  - pub  1024D/9C800ACA 2000-10-19 SuSE Package Signing Key <build@suse.de>
  - sub  2048g/8495160C 2000-10-19 [expires: 2006-02-12]
